

set frame SOAP
set frametitle "SOAP Client"
set icontitle "SOAP"

set CurrentCommand ""
set LastMethodName ""

set SOAPServerHost "localhost"
set SOAPServerPort 8015

proc make-frame {} {
   global env
   global SOAPServerHost SOAPServerPort

set rows 24
set cols 80

  :frame [self frame-name] :label "[self frame-title]" \
     :icon-name "[self icon-title]"

  :panel P1 :layout V :padx 5 :pady 5
    :layout H; :col-gap 20
     :button LOAD :label "Load source file"  :command click_load
     :button REQ  :label "Show XML request"  :command click_request
     :button RESP :label "Show XML reply"    :command click_reply
     :hskip 50
     :button CLEAR :command ":modify LIST :empty T"

  :panel P2 :layout V :padx 5 :pady 5
    :galley LIST :rows $rows :cols $cols :font variable

  :panel P3 :layout V :padx 5 :pady 5
    :layout H; :col-gap 20
    :text HOST :label "SOAP Server Host" :w 24 :value $SOAPServerHost
    :text PORT :label "SOAP Server Port" :w 5  :value $SOAPServerPort

  :panel P4 :layout B :padx 5 :pady 5
    :colour local entry foreground black
    :text CMD :label "Command:" :x 20 :bold T :size L :w [expr $cols - 20] :command do_command
    bind [:path CMD].entry <Up> "restorecommand"

   open-frame

  :galley_size LIST $rows $cols

    focus [:path CMD].entry
}

proc click-configure {W} {
   upvar #0 _LISTgalley _galley
    :galley_resize LIST
    :modify CMD :w [expr $_galley(cols) - 20]
}

proc click_request {args} {
    global LastMethodName
    insert "[SOAP::dump -request $LastMethodName]"
}

proc click_reply {args} {
    global LastMethodName
    insert "[SOAP::dump -reply $LastMethodName]"
}

proc click_load {} {midas-browser R do_load}

proc do_load {args} {
   upvar #0 browserdirectory directory
   upvar #0 browserfile file

   set f [file join $directory $file]
   cd $directory
   insert "loading $f"
   set z [catch {source $f} m]
   if {$z != 0} then {insert "$m"}
}

proc do_command {W s} {
   global CurrentCommand LastMethodName
   set CurrentCommand "$s"
   set LastMethodName [first $CurrentCommand]
   if [info complete $s] {
       set z [catch {eval $s} m]
       if {$z != 0} then {insert "$m"} else {insert "$s=> $m"}
   }
   :modify CMD :value ""
}

proc restorecommand {args} {
    global CurrentCommand
    :modify CMD :value "$CurrentCommand"

}

proc insert {s} {:modify LIST :strings $s\n}

proc click arg {
   global SOAPServerHost SOAPServerPort
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   switch $w  {
      HOST        {set SOAPServerHost $v}
      PORT        {set SOAPServerPort $v}
      default     {}
   }
}

proc start args {midas_default_frame}

proc start args {
   global started env
   upvar #0 browserdirectory directory

   if {$started == 0} then {
      make-frame
      set started 1  
      set directory [file join $env(MIDASBASE) SOAP tcl]
      cd $directory
   } else {
      open-frame
   }
}
